<?php
/**
 * Komfortkasse
 * Installer
 * @version 1.2.1.10-hhg-multistore
 * use these SQL statements to delete the configuration entries in order to re-install the plugin:
 * delete FROM object_to_store where object_id in (select configuration_id from configuration where configuration_key like 'KOMFORTKASSE%') and object_type_id=24;
 * delete from configuration where configuration_key like 'KOMFORTKASSE%';
 * delete from configuration_dummy where configuration_key like 'KOMFORTKASSE%';
 * delete from ms_box_links where box_link_name='Komfortkasse';
 */

// error_reporting(E_ALL);
// ini_set('display_errors', '1');

 function write_configuration($config_group_id, $config_key, $config_value, $use_function, $set_function, $sort_order, $store_ids) {
     global $registry;
     
     $sql_data_array = array (
             'configuration_group_id' => $config_group_id,
             'configuration_key' => $config_key,
             'configuration_value' => $config_value,
             'set_function' => $set_function,
             'use_function' => $use_function,
             'sort_order' => $sort_order,
             'is_systemDefault' => 1
     );
     $registry['db']->perform(TABLE_CONFIGURATION, $sql_data_array);
     $sql_data_array = array (
             'object_id' => $registry['db']->insert_id(),
             'object_type_id' => 24,
             'store_all' => 0
     );
     foreach ($store_ids as $store_id) {
         $sql_data_array['store_'.$store_id] = 1;
     }
     $registry['db']->perform(TABLE_OBJECT_TO_STORE, $sql_data_array);
     
     $sql_data_array = array (
             'configuration_group_id' => $config_group_id,
             'configuration_key' => $config_key,
             'configuration_value' => 'true',
             'set_function' => $set_function,
             'sort_order' => $sort_order
     );
     $registry['db']->perform(TABLE_CONFIGURATION_DUMMY, $sql_data_array);
 }
 
?>
<html>
<head>
<title>Komfortkasse Installer</title>
</head>
<body>
	<font face="Verdana,Arial,Helvetica"> <img
		src="images/komfortkasse_eu.png" border="0"><br />
		<h3>Auto Installer</h3>
<?php $steps = 9; $step=0; ?>
Note: if the installer exits before step <?php echo $steps; ?> without an error message, enable error reporting in this install.php file. (Uncomment lines 13 and 14.)

<br />
	<br />
	<b><?php echo ++$step;?>/<?php echo $steps;?></b>
Including files...

<?php
require_once ('Komfortkasse_Config.php');

chdir('../..');
require_once ('core/application_top.php');
?>

<br />
	<br />
	<b><?php echo ++$step;?>/<?php echo $steps;?></b>
Determining Language...

<?php
// require_once ('../../' . DIR_WS_CORE_CLASSES . 'class.language.php');
$lng = new language('', $registry);
$lng->get_browser_language();
echo $lng->language ['code'];
?>

<br />
	<br />
	<b><?php echo ++$step;?>/<?php echo $steps;?></b>
Checking Language additions...

<?php
$file = DIR_WS_LANGUAGES . $lng->language ['directory'] . '/admin/configuration.php';
$lines = file($file, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
foreach ( $lines as $line ) {
	if (strstr($line, Komfortkasse_Config::activate_export) !== FALSE) {
		$found = 1;
		break;
	}
}
if (!$found) {
	echo "<br/>ERROR: The configuration translation has not been added to your language files (e.g. " . $file . "). Please add the lines to the language file(s) (you can find them in the /callback/komfortkasse/lang folder) and start the installer again.";
	die();
} else {
	echo "ok";
}

?>

<br />
	<br />
	<b><?php echo ++$step;?>/<?php echo $steps;?></b>
Determining Configuration Group ID...

<?php
$config_group_q = $registry['db']->query("SELECT box_link_action FROM " . TABLE_MS_BOX_LINKS . " where box_link_name='Komfortkasse'");
$config_group_id = $config_group_q->fields['configuration_group_id'];
if ($config_group_id) {
	echo 'ERROR: Configuration group ID for "Komfortkasse" already exists. Probably the Module is already installed. This Installer will exit now.';
	die();
}

$config_group_q = $registry['db']->query("SELECT max(configuration_group_id) as maxid FROM " . TABLE_CONFIGURATION);
$config_group_id =  $config_group_q->fields ['maxid'] + 1;

echo $config_group_id;
?>

<br />
	<br />
	<b><?php echo ++$step;?>/<?php echo $steps;?></b>
Adding Admin Menu...
<?php
$menu_q = $registry['db']->query("SELECT box_link_id FROM " . TABLE_MS_BOX_LINKS . " where box_link_name='Komfortkasse'");
$menu_id = $menu_q->fields ['id'];
if (!$menu_id) {
    
    $link_id_q = $registry['db']->query("select max(box_link_id) as maxid from " . TABLE_MS_BOX_LINKS);
    $link_id = $link_id_q->fields['maxid'];
    $link_id = $link_id + 100;

    $lang_q = $registry['db']->query("select distinct languages_id from " . TABLE_MS_BOX_LINKS);
    while (!$lang_q->EOF) {
       

        $sql_data_array = array (
                'box_link_id' => $link_id, 
                'box_group_id' => 1,
                'box_link_location' => 3,
                'box_admin_class' => 3,
                'languages_id' => $lang_q->fields['languages_id'],
                'box_link_name' => 'Komfortkasse',
                'box_source_file' => 'index.php',
                'box_module' => 'configuration',
                'box_link_action' => 'gID='.$config_group_id,
                'sort_order' => $config_group_id,
                'box_link_class' => 'm'
        );
        $registry['db']->perform(TABLE_MS_BOX_LINKS, $sql_data_array);
        $lang_q->MoveNext();
    }
    
}
echo "ok";
?>

<br />
	<br />
	<b><?php echo ++$step;?>/<?php echo $steps;?></b>
Getting store IDs ...

<?php

$stores_q = $registry['db']->query("SELECT store_id FROM " . TABLE_MS_STORE);
while (!$stores_q->EOF) {
    $store_ids[] = $stores_q->fields['store_id'];
    echo $stores_q->fields['store_id'];
    $stores_q->MoveNext();
}

?>

<br />
	<br />
	<b><?php echo ++$step;?>/<?php echo $steps;?></b>
Creating Configuration ...

<?php

$sort_order = 1;

write_configuration($config_group_id, Komfortkasse_Config::activate_export, 'true', null, 'xtc_cfg_select_option(array(\'true\', \'false\'),', $sort_order, $store_ids);
$sort_order++;
write_configuration($config_group_id, Komfortkasse_Config::activate_update, 'true', null, 'xtc_cfg_select_option(array(\'true\', \'false\'),', $sort_order, $store_ids);
$sort_order++;
write_configuration($config_group_id, Komfortkasse_Config::payment_methods, 'moneyorder,eustandardtransfer', null, null, $sort_order, $store_ids);
$sort_order++;
write_configuration($config_group_id, Komfortkasse_Config::status_open, '1', null, null, $sort_order, $store_ids);
$sort_order++;
write_configuration($config_group_id, Komfortkasse_Config::status_paid, '2', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(', $sort_order, $store_ids);
$sort_order++;
write_configuration($config_group_id, Komfortkasse_Config::status_cancelled, '3', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(', $sort_order, $store_ids);
$sort_order++;
write_configuration($config_group_id, Komfortkasse_Config::encryption, '', null, null, $sort_order, $store_ids);
$sort_order++;
write_configuration($config_group_id, Komfortkasse_Config::accesscode, '', null, null, $sort_order, $store_ids);
$sort_order++;
write_configuration($config_group_id, Komfortkasse_Config::publickey, '', null, null, $sort_order, $store_ids);
$sort_order++;
write_configuration($config_group_id, Komfortkasse_Config::privatekey, '', null, null, $sort_order, $store_ids);
$sort_order++;
write_configuration($config_group_id, Komfortkasse_Config::apikey, '', null, null, $sort_order, $store_ids);
$sort_order++;

echo $sort_order;

?>

<br />
	<br />
	<b><?php echo ++$step;?>/<?php echo $steps;?></b>
Modifying .htaccess file...
<?php
$ok = 0;
chdir('callback/komfortkasse');
if (rename('.htaccess', '_htaccess.beforeinstall') === TRUE) {
	if (rename('_htaccess.afterinstall', '.htaccess') === TRUE) {
		$ok = 1;
	}
}
if ($ok) {
	echo "ok";
} else {
	echo "Important: your .htaccess file could not be changed. For improved security, please change your .htaccess file so that the install.php script cannot be executed, or rename install.php.";
}

?>

<br />
	<br />
	<b><?php echo ++$step;?>/<?php echo $steps;?></b> Finished. <a
		href="<?php echo HTTP_SERVER?>/admin/index.php?module=configuration&gID=<?php echo $config_group_id; ?>"
		target="_new">Please check the configuration now.</a><br /> (If you
		cannot access this link, please login to your admin panel and open the
		Komfortkasse configuration from the menu - should be the last menu
		entry.)<br /> <br /> <br />
		<h3>Instant order transmission</h3> New orders will be read
		periodically from your online shop. Additionally, you can activate <b>instant
			order transmission</b>, which will transmit any new order
		immediately. This way, your customer will receive payment information
		immediately. We encourage you to activate instant order transmission.
		In order to activate instant order transmission, edit the following
		files:<br /> <br /> <b>/admin/orders.php</b>, around line 132: <pre>
$registry['db']->query("insert into " . TABLE_ORDERS_STATUS_HISTORY . " ...
<b>
// BEGIN Komfortkasse
include_once '../callback/komfortkasse/Komfortkasse.php';
$k = new Komfortkasse();
$k->notifyorder($oID);
// END Komfortkasse
</b>
$order_updated = true;
</pre> <br /> <b>/includes/modules/payment/moneyorder.php</b>,
		or any other payment module that will be used with Komfortkasse (e.g.
		banktransfer, moneyorder), in function after_process, at the end of
		the function: <pre>
<b>
// BEGIN Komfortkasse
include_once './callback/komfortkasse/Komfortkasse.php';
$k = new Komfortkasse();
$k->notifyorder($insert_id);
// END Komfortkasse
</b>
</pre> <br /> <b>store_files/[your store IDs]/lang/[your languages]/plugins/payment/moneyorder.php</b>, or any other
		payment module that will be used with Komfortkasse (e.g. banktransfer,
		eustandardtransfer), change the MODULE_PAYMENT_[...]_TEXT_DESCRIPTION constant
		(e.g. MODULE_PAYMENT_MONEYORDER_TEXT_DESCRIPTION): <pre>
<b>
// german
define('MODULE_PAYMENT_MONEYORDER_TEXT_DESCRIPTION', '&lt;br /&gt;Sie erhalten nach Bestellannahme die Kontodaten in einer gesonderten E-Mail.');

// english
define('MODULE_PAYMENT_MONEYORDER_TEXT_DESCRIPTION', '&lt;br /&gt;After your order is confirmed, you will receive payment details in a separate e-mail.');
</b>
</pre>

	</font>
</body>
</html>

